// TestArrayOp class for ArrayOp lab
// This class tests the array operation methods

// (c) J. Dean Brock, Rebecca F. Bruce, 2001, 2004
// Department of Computer Science
// University of North Carolina at Asheville

package edu.unca.cs.csci201.LabAids;

/**
 * Tests the array operation methods
 */
public class TestArrayOp {

    private static final int ArrayMinSize =  7 ;
    private static final int ArrayMaxSize = 10 ;
    
    private static String printInt(int I, int W) {
        String R = Integer.toString(I) ;
        for (int i=R.length(); i<W; ++i)
            R = " " + R ;
        return R ;
    }
    
    /**
     * Generates a random array and calls the array operation
     * method.  Prints the array and the value returned by
     * the array opeation.
     * @param testObj Class to be tested.  Must follow the SpecArrayOp
     * interface.
     */    
    public static void TestArrayOperation(SpecArrayOp testObj,
                                          int SolutionSet) {
        TestArrayOperation(testObj, SolutionSet, System.out) ;
    }
    
    static void TestArrayOperation(SpecArrayOp testObj,
                                   int SolutionSet,
                                   java.io.PrintStream printOut) {
        // generate the random array                                      
        edu.unca.cs.LabAids.TestValues runTestSet = 
                    new edu.unca.cs.LabAids.TestValues(SolutionSet) ;

        int ArraySize = Math.abs(runTestSet.getIthInteger(0)) %
                            (ArrayMaxSize-ArrayMinSize) + ArrayMinSize ;
        int testVect[] = new int[ArraySize] ;
        for (int i=0; i<ArraySize; ++i)
            testVect[i] = runTestSet.getIthInteger(i+1) ;
        
        printOut.println("Testing " + testObj.getClass().getName()) ;
        printOut.print("  ") ;
        if (ArraySize>0)
            printOut.print(printInt(testVect[0],2)) ;
        for (int i=1; i<ArraySize; ++i)
            printOut.print(", " + printInt(testVect[i],2)) ;
        
        try {
            // Call the array operation
            int TestRes = testObj.TestFunc(testVect) ;
            printOut.println(" ==> " + printInt(TestRes,2)) ;
        } catch (Exception E) {
            printOut.println(" ==> " + E) ;
        }
        printOut.println() ;
    }
}
